#stan version 2.10
library(rstan)
library(circular)

##tHE~[[Xz
#ANZX
checkin_data<-as.circular(read.csv("data14.csv",header=T),
units="hours",control.circular=list(modulo="2pi"))
x<-checkin_data
for (i in 1:length(checkin_data)){
	x[i]<-as.vector((checkin_data[i]/24)*(2*pi))
}

#2ꐔ
scr<-"code14_1.stan"
data<-list(N=nrow(x),x=x[,1])
par<-c("logLike")
war<-250        
ite<-500       
see<-1234      
dig<-3         
cha<-4

fit1<-stan(file=scr, model_name=scr, data=data, pars=par,verbose=F, seed=see, 
	chains=cha, warmup=war, iter=ite)
print(fit1,pars=par,digits_summary=dig)

logL<-extract(fit1)$logLike
lppd<-mean(log(colMeans(exp(logL))))
p_waic<-mean(colMeans(logL^2)-colMeans(logL)^2)
(waic1<- -2*lppd+2*p_waic)


#3ꐔ
scr<-"code14_2.stan"
data<-list(N=nrow(x),x=x[,1])
par<-c("logLike")
war<-250        
ite<-500       
see<-1234      
dig<-3         
cha<-4
         
fit2<-stan(file=scr, model_name=scr, data=data, pars=par,verbose=F, seed=see,
	 chains=cha, warmup=war, iter=ite)
print(fit2,pars=par,digits_summary=dig)                  

logL<-extract(fit2)$logLike
lppd<-mean(log(colMeans(exp(logL))))
p_waic<-mean(colMeans(logL^2)-colMeans(logL)^2)
(waic2<- -2*lppd+2*p_waic)


#4ꐔ
scr<-"code14_3.stan"
data<-list(N=nrow(x),x=x[,1])
par<-c("mu1","mu2","mu3","mu4","sigma","theta","logLike","v","V")
war<-250        
ite<-500       
see<-1234      
dig<-3         
cha<-4

fit3<-stan(file=scr, model_name=scr, data=data, pars=par,verbose=F, seed=see,
	 chains=cha, warmup=war, iter=ite)
print(fit3,pars=c("V","v"),digits_summary=dig) 
                  
logL<-extract(fit3)$logLike
lppd<-mean(log(colMeans(exp(logL))))
p_waic<-mean(colMeans(logL^2)-colMeans(logL)^2)
(waic3<- -2*lppd+2*p_waic)

mu1<-extract(fit3)$mu1;mu2<-extract(fit3)$mu2
mu3<-extract(fit3)$mu3;mu4<-extract(fit3)$mu4

round(mean.circular(mu1,control.circular=list(modulo="2pi"))*(180/pi),3)
round(mean.circular(mu2,control.circular=list(modulo="2pi"))*(180/pi),3)
round(mean.circular(mu3,control.circular=list(modulo="2pi"))*(180/pi),3)
round(mean.circular(mu4,control.circular=list(modulo="2pi"))*(180/pi),3)

pro <- c(0.025, 0.5, 0.975)   
round(quantile(mu1,probs=pro,control.circular=list(modulo="2pi"))*(180/pi),3)
round(quantile(mu2,probs=pro,control.circular=list(modulo="2pi"))*(180/pi),3)
round(quantile(mu3,probs=pro,control.circular=list(modulo="2pi"))*(180/pi),3)
round(quantile(mu4,probs=pro,control.circular=list(modulo="2pi"))*(180/pi),3)

round(sd.circular(mu1,control.circular=list(modulo="2pi"))*(180/pi),3)
round(sd.circular(mu2,control.circular=list(modulo="2pi"))*(180/pi),3)
round(sd.circular(mu3,control.circular=list(modulo="2pi"))*(180/pi),3)
round(sd.circular(mu4,control.circular=list(modulo="2pi"))*(180/pi),3)
