data {
	int<lower=0> N;
	real<lower=0.999> x[N];
}
parameters {
	real<lower=0.0001>  alpha;  
	real<lower=0.0001>   beta;
}
model {
       for(i in 1:N){
	x[i] ~ gamma(alpha,beta);
	}
}
generated quantities{
	vector[N] log_lik;
	
	for(i in 1:N){
		log_lik[i] = gamma_lpdf(x[i]|alpha,beta);
	}
}
