data {
	int<lower=0> I;
	real y[I];
}

transformed data {
	real b ;
	real c ;

	b = sqrt(2/pi());
	c = square(4.0-pi());
}
parameters {
	real mu1;		//
	real<lower=0> mu2;	//U
	real<lower=-0.99,upper= +0.99>   mu3;	//cx
}
transformed parameters{
	real d ;
	real t1;
	real t2;
	real t3;
	real delta;

	d = cbrt(4.0*square(mu3)/c);
	t3 = (mu3/fabs(mu3))*sqrt(((pi()/2.0)*d)/(1.0-((pi()/2.0)-1.0)*d));
	delta = t3/sqrt(1+square(t3));
	t1 = mu1 + (-b*delta) * sqrt(1.0*mu2 / (1.0-square(b*delta)));
	t2 = mu2*(1.0/(1.0-square(b*delta)));
}
model{
	mu3  ~  uniform(-0.99, 0.99);
	for(i in 1:I){
		y[i] ~ skew_normal(t1, sqrt(t2), t3);
	}
}
generated quantities{
	real log_lik;
	
	log_lik = skew_normal_lpdf(y | t1, sqrt(t2), t3);  //ΐޓx
}
