data {
	int<lower=0> I1;
	int<lower=0> I2;
	real y1[I1];
	real y2[I2];
}

transformed data {
	real b ;
	real c ;

	b = sqrt(2/pi());
	c = square(4.0-pi());
}
parameters {
	//1Q
	real 							mu1_g1;	//
	real<lower=0> 					mu2_g1;	//U
	real<lower=0,upper= +0.99>		mu3_g1;	//cx
//	real<lower=-0.99,upper= +0.99>	mu3_g1;	//cx
	//2Q
	real 							mu1_g2;	//
}

transformed parameters{
	//1Q
	real d_g1 ;
	real t1_g1;
	real t2_g1;
	real t3_g1;
	real delta_g1;
	//2Q
	real<lower=0> 					mu2_g2; //U
	real<lower=0,upper= +0.99>	 	mu3_g2;	//cx
//	real<lower=-0.99,upper= +0.99> 	mu3_g2;	//cx
	real d_g2 ;
	real t1_g2;
	real t2_g2;
	real t3_g2;
	real delta_g2;

	//1Q
	d_g1 = cbrt(4.0*square(mu3_g1)/c);
	t3_g1 = (mu3_g1/fabs(mu3_g1))*sqrt(((pi()/2.0)*d_g1)/(1.0-((pi()/2.0)-1.0)*d_g1));
	delta_g1 = t3_g1/sqrt(1+square(t3_g1));
	t1_g1 = mu1_g1 + (-b*delta_g1) * sqrt(1.0*mu2_g1 / (1.0-square(b*delta_g1)));
	t2_g1 = mu2_g1 * (1.0/(1.0-square(b*delta_g1)));

	//2Q
	mu2_g2 = mu2_g1;
	mu3_g2 = mu3_g1;
	d_g2 = cbrt(4.0*square(mu3_g2)/c);
	t3_g2 = (mu3_g2/fabs(mu3_g2))*sqrt(((pi()/2.0)*d_g2)/(1.0-((pi()/2.0)-1.0)*d_g2));
	delta_g2 = t3_g2/sqrt(1+square(t3_g2));
	t1_g2 = mu1_g2 + (-b*delta_g2) * sqrt(1.0*mu2_g2 / (1.0-square(b*delta_g2)));
	t2_g2 = mu2_g2 * (1.0/(1.0-square(b*delta_g2)));
}
model{
	//1Q
	mu3_g1  ~  uniform(0, 0.99);
//	mu3_g1  ~  uniform(-0.99, 0.99);
	for(i in 1:I1){
		y1[i] ~ skew_normal(t1_g1, sqrt(t2_g1), t3_g1);
	}
	//2Q
//	mu3_g2  ~  uniform(-0.99, 0.99);
	for(i in 1:I2){
		y2[i] ~ skew_normal(t1_g2, sqrt(t2_g2), t3_g2);
	}
}
generated quantities{
	real log_lik;
	
	log_lik = skew_normal_lpdf(y1 | t1_g1, sqrt(t2_g1), t3_g1) + 
				skew_normal_lpdf(y2 | t1_g2, sqrt(t2_g2), t3_g2);  #ΐޓx
}
