data { 
	int<lower=0> N;
	int<lower=0> y[N];
	real<lower=0> x1[N];
	real<lower=0> x2[N];
	real<lower=0> x3[N];
}
parameters {
	real<lower=0> phi;
	real b;
	real a1;
	real a2;
	real a3;
}
model {
	for(i in 1:N){
		y[i] ~ neg_binomial_2_log(b+a1*x1[i]+a2*x2[i]+a3*x3[i], phi);
	}
}
