data{
	int<lower=0> N;
	int<lower=0> S[N];
	int<lower=0> y[N];
	real<lower=0> edu[N];
	real<lower=0> sex[N];
}
parameters{
	real b;
	real a1;
	real a2;
}
transformed parameters{
	real<lower=0,upper=1> p[N];
	for(i in 1:N){
		p[i] = inv_logit(b+a1*edu[i]+a2*sex[i]);
		#p[i] = Phi(b + a1 * edu[i] + a2 * sex[i]);
		#p[i] = 1-exp(-exp(b+a1*edu[i]+a2*sex[i]));
		#p[i] = exp(b+a1*edu[i]+a2*sex[i]);
	}
}
model{
	for(i in 1:N){
		y[i] ~ binomial(S[i], p[i]);
		#y[i] ~ binomial(S[i], inv_logit(b+a1*edu[i]+a2*sex[i]));
		#y[i] ~ binomial_logit(S[i], b+a1*edu[i]+a2*sex[i]);
	}
}
generated quantities{
	real log_lik[N];
	real OR_sex1;
	real OR_sex0;
	for(i in 1:N)
		log_lik[i] = binomial_lpmf(y[i]|S[i],p[i]);
	OR_sex1 = exp(a2); #̒jɑ΂IbY
	OR_sex0 = exp(-a2); #j̏ɑ΂IbY
	#OR_sex1 = 1/exp(-a2); #exp(a2)Ɠʂ𓾂
	#OR_sex0 = 1/exp(a2); #exp(-a2)Ɠʂ𓾂
}
# OR_sex0 = exp(a2) = 1/(exp(-a2)) = 1/OR_sex1łB
# IbY͒`OR_sex0 = 1/OR_sex1C
# OR_sex0EAPlƐOR_sex1EAPl̋tƂ͕KvȂB
