//stan2.10

rowdata<-data.frame(O=c(0,0,0,0,1,0,0,0,0,0,0,0,
                        0,0,0,0,0,0,0,1,0,0,0,0,
                        1,1,1,1,0,1,1,1,0,1,0,1),
                    S=c(0,0,0,0,1,0,0,0,0,0,0,0,
                        0,0,0,0,0,0,0,1,0,1,0,0,
                        1,1,1,1,1,1,1,0,0,1,0,1))
table<-table(rowdata)

#===Analysis
y<-c(t(table))
point<-0.6

data<-list(y=y,point=point)
parameters<-c("p","kappa","test")


library(rstan)

kappa_samples <- stan(file="code31_2.stan",   
                      data=data,  
                      pars=parameters,
                      iter=10000, 
                      chains=4, 
                      thin=1,
                      warmup=5000,  
                      seed=1234  
)

#===͌
print(kappa_samples)

result<-round(summary(kappa_samples)$summary[,c(1,3,4,6,8)],2)
(result)

#===Tv̎o
post_kappa<-extract(kappa_samples)$kappa

#===㕪z
hist(post_kappa,breaks=100,probability=T)


