### WAIC (Stan 2.11ȍ~)
# StanRɂWAICvZ
library(rstan)

# Ꭶf[^
source("data52.R")

war<-1000
ite<-11000
dig<-3
cha<-5
see<-1234

# f1
sm1 <- stan_model(model_code='
data{
	int<lower=0> N;
	vector[N] x;
	vector[N] y;
}
parameters{
	real b;
	real a;
	real<lower=0> sigma;
}
transformed parameters{
	real mu[N];
	for(i in 1:N)
		mu[i] = b + a*x[i];
}
model{
	for(i in 1:N){
		y[i] ~ normal(mu[i],sigma);
	}
}
generated quantities{
	vector[N] log_lik;
	for(i in 1:N){
	//f1̑ΐޓx
		log_lik[i] = normal_lpdf(y[i]|mu[i],sigma);
	}
}')

par <- c("a","b","sigma","log_lik")
dat <- list(N=N,y=y,x=x)
stanfit1 <- sampling(sm1,iter=ite,chains=cha,warmup=war,data=dat,seed=see,pars=par)
print(stanfit1,digits_summary=dig)

################################################################
#f2
sm2 <- stan_model(model_code='
data{
	int<lower=0> N;
	vector[N] x;
	vector[N] y;
}
parameters{
	real a;
	real<lower=0> sigma;
}
transformed parameters{
	real mu[N];
	for(i in 1:N)
		mu[i] = a*x[i];
}
model{
	for(i in 1:N){
		y[i] ~ normal(mu[i],sigma);
	}
}
generated quantities{
	vector[N] log_lik;
	for(i in 1:N){
	//f2̑ΐޓx
		log_lik[i] = normal_lpdf(y[i]|mu[i],sigma);
	}
}')

par <- c("a","sigma","log_lik")
dat <- list(N=N,y=y,x=x)
stanfit2 <- sampling(sm2,iter=ite,chains=cha,warmup=war,data=dat,seed=see,pars=par)
print(stanfit2 ,digits_summary=dig)

################################################################
# pbP[WloopWAIC̎Zo

library(loo)
log_lik1 <- extract_log_lik(stanfit1)

round(head(log_lik1),2)
dim(log_lik1)

# f1WAIC
waic1 <- waic(log_lik1)
print(waic1 , digits = dig)

# f2WAIC
log_lik2 <- extract_log_lik(stanfit2)
waic2 <- waic(log_lik2)
print(waic2 , digits = dig)

# WAIC̔r
compare(waic1, waic2)

################################################################
# RXNvgɂWAIC̎Zo

#f1
log_lik <- extract(stanfit1)$log_lik
lppd <- sum(log(colMeans(exp(log_lik))))
p_waic <- sum(apply(log_lik,2,var))
waic <- -2*lppd + 2*p_waic
round(waic,3)

#f2
log_lik <- extract(stanfit2)$log_lik
lppd <- sum(log(colMeans(exp(log_lik))))
p_waic <- sum(apply(log_lik,2,var))
waic <- -2*lppd + 2*p_waic
round(waic,3)





